#!/bin/bash
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
INSTALLDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )"/../.. && pwd )"

HOST=`hostname`
echo "* Update HTTPD conf for $HOST"

cat > /etc/httpd/conf.d/radmin.conf<<EOF
<VirtualHost *:80>
    ServerName default
    DocumentRoot /var/www/html/radmin
    <Location />
        Require all denied
    </Location>
</VirtualHost>

<VirtualHost *:80>
    UseCanonicalName Off
    DocumentRoot /var/www/html/radmin
    ServerName ipconnect.fr
    ServerAlias $HOST

    <Directory "/var/www/html/radmin">
            Require all granted
            Options FollowSymlinks
            Options -Indexes
            AllowOverride all
    </Directory>
</VirtualHost>
EOF

systemctl restart httpd

echo "* Adding Fail2ban"
systemctl enable fail2ban

cat > /etc/fail2ban/jail.d/httpd-403.conf <<EOF
[httpd-403]
enabled = true
port = http,https
filter = httpd-403
action = iptables-multiport[name=ALL, port="http,https"]
logpath = /var/log/httpd/access_log
maxretry = 5
findtime = 600
bantime  = 3600
ignoreip = 82.251.5.198/32
EOF

cat > /etc/fail2ban/filter.d/httpd-403.conf <<EOF
[Definition]
failregex = ^<HOST> .* 403 - .*$
ignoreregex =^82.251.5.198.*
EOF

rm -f /etc/fail2ban/jail.d/00-firewalld.conf
systemctl restart fail2ban
